// SerializeXML.h: interface for the CSerializeXML class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SERIALIZEXML_H__392D43DD_65A2_4297_9802_B369FE179C6E__INCLUDED_)
#define AFX_SERIALIZEXML_H__392D43DD_65A2_4297_9802_B369FE179C6E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <vector>
#include <comdef.h>
using namespace std;

struct FirstSub1Struct
{
	_bstr_t someName;
	int someNumber;
};

struct FirstSub2Struct
{
	_bstr_t someName;
	int someNumber;
};

struct FirstStruct
{
	_bstr_t someName;
	int someNumber;
	vector<FirstSub1Struct> firstSub1;
	vector<FirstSub2Struct> firstSub2;
};

struct SecondStruct
{
	int someNumber1;
	int someNumber2;
};

struct MainStruct
{
	vector<FirstStruct>  first;
	vector<SecondStruct> second;
};

class CSerializeXML  
{
public:
	CSerializeXML();
	virtual ~CSerializeXML();

   bool SaveConfigurationToDisk(_bstr_t file, MainStruct* pMainStruct);
   bool LoadConfigurationFromDisk(_bstr_t file, MainStruct* pMainStruct);

protected:
	IXMLDOMDocumentPtr m_plDomDocument;
	IXMLDOMElementPtr m_pDocRoot;

protected:
   void BuildMainStruct(IXMLDOMNodePtr pParent, MainStruct &mainStruct);
   void BuildFirstStruct(IXMLDOMNodePtr pParent, FirstStruct &firstStruct);
   void BuildFirstSub1Struct(IXMLDOMNodePtr pParent, FirstSub1Struct &firstSub1Struct);
   void BuildFirstSub2Struct(IXMLDOMNodePtr pParent, FirstSub2Struct &firstSub2Struct);
   void BuildSecondStruct(IXMLDOMNodePtr pParent, SecondStruct &secondStruct);
};

#endif // !defined(AFX_SERIALIZEXML_H__392D43DD_65A2_4297_9802_B369FE179C6E__INCLUDED_)
